PROGRAM test_layout_array
  USE realdatalayout
  USE system_tools 
  USE mpi
  USE realparallel
  USE values

  IMPLICIT NONE

  TYPE (REAL_DATA_LAYOUT) :: val
  INTEGER:: i, nbcpus, me, ierr
  INTEGER, PARAMETER:: nx=4096,ny=2048

  !------------------------------------------------
  ! Initialize the mpi environnememnt
  !------------------------------------------------
  CALL MPI_INIT(ierr)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,me,ierr)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,nbcpus,ierr)
  DO i=1,20000
     if (real_initDataLayout(val,nx,ny,nbcpus,me)) then
        !CALL set(val)
        if (real_setAlongY(me,val)) then
          !CALL check(val,me)
          if (real_setAlongX(me,val)) then
             !CALL check(val,me)
          endif
        endif
        call show_memory(me)
        CALL real_deleteDataLayout(val)
     else
       PRINT*,"Probleme"
     endif
  ENDDO

  CALL MPI_FINALIZE(ierr)

END PROGRAM test_layout_array
