MODULE values
  USE realdatalayout
  IMPLICIT NONE

  CONTAINS

  SUBROUTINE set(val)
  IMPLICIT NONE
  TYPE (REAL_DATA_LAYOUT), INTENT(INOUT) :: val

  INTEGER:: i,j

  DO i=val%xmin, val%xmax
     DO j=val%ymin, val%ymax
        val%values(i,j)= i*1000+j
     ENDDO
  ENDDO
  END SUBROUTINE set

  SUBROUTINE check (val,me)
  IMPLICIT NONE
  TYPE (REAL_DATA_LAYOUT), INTENT(IN) :: val
  INTEGER, INTENT(IN)                    :: me

  INTEGER :: i,j
  LOGICAL :: OK

  OK=.TRUE.
  DO i=val%xmin, val%xmax
     DO j=val%ymin, val%ymax
        IF(val%values(i,j) .NE. i*1000+j) THEN
          WRITE(6,'(3(a,i0))') "On ",me," found ",val%values(i,j)," but expect ", i*1000+j
          OK=.FALSE.
        ENDIF
     ENDDO
  ENDDO
  IF (.NOT. OK) STOP "FAILED"
  END SUBROUTINE check


END MODULE values
